"use strict";

GSUsetTemplate( "gsui-fx-filter", () => [
	GSUcreateDiv( { class: "gsuiFxFilter-area gsuiFxFilter-areaType" },
		GSUcreateSpan( { class: "gsuiFxFilter-area-label" }, "type" ),
		GSUcreateDiv( { class: "gsuiFxFilter-area-content" },
			GSUgetTemplate( "gsui-fx-filter-type", "lowpass",   "M 1 4 L 12 4 L 15 8" ),
			GSUgetTemplate( "gsui-fx-filter-type", "highpass",  "M 1 8 L 4 4 L 15 4" ),
			GSUgetTemplate( "gsui-fx-filter-type", "bandpass",  "M 1 8 L 8 4 L 15 8" ),
			GSUgetTemplate( "gsui-fx-filter-type", "lowshelf",  "M 1 8 L 4 8 L 6 4 L 15 4" ),
			GSUgetTemplate( "gsui-fx-filter-type", "highshelf", "M 1 4 L 10 4 L 12 8 L 15 8" ),
			GSUgetTemplate( "gsui-fx-filter-type", "peaking",   "M 1 8 L 7 8 L 8 4 L 9 8 L 15 8" ),
			GSUgetTemplate( "gsui-fx-filter-type", "notch",     "M 1 4 L 7 4 L 8 8 L 9 4 L 15 4" ),
			GSUgetTemplate( "gsui-fx-filter-type", "allpass",   "M 1 6 L 15 6" ),
		),
	),
	GSUcreateDiv( { class: "gsuiFxFilter-area gsuiFxFilter-areaGraph" },
		GSUcreateSpan( { class: "gsuiFxFilter-area-label" }, "frequency" ),
		GSUcreateDiv( { class: "gsuiFxFilter-area-content" },
			GSUcreateElement( "gsui-curves" ),
		),
	),
	GSUcreateDiv( { class: "gsuiFxFilter-area gsuiFxFilter-areaFrequency" },
		GSUcreateDiv( { class: "gsuiFxFilter-area-content" },
			GSUcreateElement( "gsui-slider", { type: "linear-x", min: 0, max: 1, step: .0001, "data-prop": "frequency" } ),
		),
	),
	GSUcreateDiv( { class: "gsuiFxFilter-area gsuiFxFilter-areaGain" },
		GSUcreateSpan( { class: "gsuiFxFilter-area-label" }, "gain" ),
		GSUcreateDiv( { class: "gsuiFxFilter-area-content" },
			GSUcreateElement( "gsui-slider", { type: "linear-y", min: -50, max: 50, step: .1, "mousemove-size": 400, "data-prop": "gain" } ),
		),
	),
	GSUcreateDiv( { class: "gsuiFxFilter-area gsuiFxFilter-areaQ" },
		GSUcreateSpan( { class: "gsuiFxFilter-area-label" }, "Q" ),
		GSUcreateDiv( { class: "gsuiFxFilter-area-content" },
			GSUcreateElement( "gsui-slider", { type: "circular", min: .001, max: 25, step: .001, "mousemove-size": 400, "data-prop": "Q" } ),
		),
	),
	GSUcreateDiv( { class: "gsuiFxFilter-area gsuiFxFilter-areaDetune" },
		GSUcreateSpan( { class: "gsuiFxFilter-area-label" }, "detune" ),
		GSUcreateDiv( { class: "gsuiFxFilter-area-content" },
			GSUcreateElement( "gsui-slider", { type: "circular", min: -1200, max: 1200, step: 10, "mousemove-size": 400, "data-prop": "detune" } ),
		),
	),
] );

GSUsetTemplate( "gsui-fx-filter-type", ( type, d ) =>
	GSUcreateButton( { class: "gsuiFxFilter-areaType-btn", "data-type": type, title: type },
		GSUcreateElementSVG( "svg", { viewBox: "0 0 16 12" },
			GSUcreateElementSVG( "path", { d } ),
		),
	)
);
